%define ALD_Ver		2.0

Name:         cups-pdf

License:      GPLv2
Summary:      PDF writer backend for CUPS
Group:        Applications/Publishing
Version:      3.0.1
Release:      0

URL:          https://www.cups-pdf.de/
#https://www.cups-pdf.de/src/

Source: %{name}-%{version}.tar.xz
Source2: %{name}-%{version}-patches.tgz

Requires:     /usr/bin/pgrep


%define DestDir		/ps_pdf_printer
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
PDF writer backend for CUPS

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

tar -xzf %SOURCE2
patch -p0<patches/div.patch

#sed -i s:"#Out /var/spool/cups-pdf/\${USER}":"Out \${HOME}/PDF": extra/cups-pdf.conf
#sed -i s:"#DecodeHexStrings 0":"DecodeHexStrings 1": extra/cups-pdf.conf

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -falign-functions=4 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -fno-stack-protector -std=gnu99"

cd src
gcc $OPTFLAGS -lcups -o cups-pdf cups-pdf.c &>../FMake_log.txt
cd ..

# ------------------- Install ----------------------------------------
%Install

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

cp COPYING README patches/INSTALL.cups-pdf.txt $RPM_BUILD_ROOT%{docdir}/

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/cups
cp -a extra/cups-pdf.conf $RPM_BUILD_ROOT/%{_sysconfdir}/cups/cups-pdf.conf.default

mkdir -p $RPM_BUILD_ROOT%{_libdir}/cups/backend
cp src/cups-pdf $RPM_BUILD_ROOT%{_libdir}/cups/backend/
chmod 0700 $RPM_BUILD_ROOT%{_libdir}/cups/backend/cups-pdf

mkdir -p $RPM_BUILD_ROOT%{_datadir}/cups/model
cp extra/CUPS-PDF_noopt.ppd $RPM_BUILD_ROOT%{_datadir}/cups/model/
cp extra/CUPS-PDF_opt.ppd $RPM_BUILD_ROOT%{_datadir}/cups/model/

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/cups-pdf
chmod 0775 $RPM_BUILD_ROOT%{_localstatedir}/spool/cups-pdf
#mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/cups-pdf/SPOOL
#chmod 0775 $RPM_BUILD_ROOT%{_localstatedir}/spool/cups-pdf/SPOOL


%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local


# ------------------- post ------------------------------------------
%pretrans
pgrep -u root -f cupsd >/dev/null
if test $? = "1" ; then
  echo "--- ERROR: cups not run ---"
  exit 1
fi

%posttrans
if test ! -e /etc/cups/cups-pdf.conf; then
  cp /etc/cups/cups-pdf.conf.default /etc/cups/cups-pdf.conf
fi

if pgrep -u root -f cupsd >/dev/null ; then
  /usr/sbin/lpadmin -p Cups-PDF -v cups-pdf:/ -m CUPS-PDF_noopt.ppd -E || :
fi

%preun
pgrep -u root -f cupsd >/dev/null
if test $? = "1" ; then
  echo "--- ERROR: cups not run ---"
  exit 1
fi

%postun
if pgrep -u root -f cupsd >/dev/null ; then
  /usr/sbin/lpadmin -x Cups-PDF || :
fi

# ------------------- Files ------------------------------------------
%Files
%{_sysconfdir}/cups/cups-pdf.conf.default
%{_libdir}/cups/backend/cups-pdf
%{_datadir}/cups/model
%dir %{_localstatedir}/spool/cups-pdf
#dir %{_localstatedir}/spool/cups-pdf/SPOOL
%{docdir}
